<a id="mypy-boto3-codeguru-reviewer"></a>

# mypy-boto3-codeguru-reviewer

[![PyPI - types-aiobotocore-codeguru-reviewer](https://img.shields.io/pypi/v/types-aiobotocore-codeguru-reviewer.svg?color=blue)](https://pypi.org/project/types-aiobotocore-codeguru-reviewer)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-codeguru-reviewer.svg?color=blue)](https://pypi.org/project/types-aiobotocore-codeguru-reviewer)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-codeguru-reviewer?color=blue)](https://pypistats.org/packages/types-aiobotocore-codeguru-reviewer)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.CodeGuruReviewer 1.20.47](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/codeguru-reviewer.html#CodeGuruReviewer)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[types-aiobotocore-codeguru-reviewer docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_codeguru_reviewer/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-codeguru-reviewer](#mypy-boto3-codeguru-reviewer)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `CodeGuruReviewer`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `CodeGuruReviewer` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[codeguru-reviewer]'

# Lite version does not provide session.create_client overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[codeguru-reviewer]'

# standalone installation
python -m pip install types-aiobotocore-codeguru-reviewer
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[codeguru-reviewer]` in your environment:
  `python -m pip install 'types-aiobotocore[codeguru-reviewer]'`

Both type checking and auto-complete should work for `CodeGuruReviewer`
service. No explicit type annotations required, write your `boto3` code as
usual.

<a id="pycharm"></a>

### PyCharm

- Install `types-aiobotocore[codeguru-reviewer]` in your environment:
  `python -m pip install 'types-aiobotocore[codeguru-reviewer]'`

Both type checking and auto-complete should work for `CodeGuruReviewer`
service. No explicit type annotations required, write your `aiobotocore` code
as usual. Auto-complete can be slow on big projects or if you have a lot of
installed `types-aiobotocore` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[codeguru-reviewer]` in your environment:
  `python -m pip install 'types-aiobotocore[codeguru-reviewer]'`
- Run `mypy` as usual

Type checking should work for `CodeGuruReviewer` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `types-aiobotocore[codeguru-reviewer]` in your environment:
  `python -m pip install 'types-aiobotocore[codeguru-reviewer]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `CodeGuruReviewer` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`CodeGuruReviewerClient` provides annotations for
`session.create_client("codeguru-reviewer")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_codeguru_reviewer import CodeGuruReviewerClient

session = get_session()
async with session.create_client("codeguru-reviewer") as client:
    client: CodeGuruReviewerClient
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_codeguru_reviewer.paginator` module contains type
annotations for all paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_codeguru_reviewer import CodeGuruReviewerClient
from types_aiobotocore_codeguru_reviewer.paginator import (
    ListRepositoryAssociationsPaginator,
)

session = get_session()
async with session.create_client("codeguru-reviewer") as client:
    client: CodeGuruReviewerClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        list_repository_associations_paginator: ListRepositoryAssociationsPaginator = client.get_paginator("list_repository_associations")
    ```


### Waiters annotations

`types_aiobotocore_codeguru_reviewer.waiter` module contains type annotations for all waiters.

```python
from aiobotocore.session import get_session

from types_aiobotocore_codeguru_reviewer.client import CodeGuruReviewerClient
from types_aiobotocore_codeguru_reviewer.waiter import (
    CodeReviewCompletedWaiter,
    RepositoryAssociationSucceededWaiter,
)

session = get_session()
async with session.create_client("codeguru-reviewer") as client:
    client: CodeGuruReviewerClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        code_review_completed_waiter: CodeReviewCompletedWaiter = client.get_waiter("code_review_completed")
        repository_association_succeeded_waiter: RepositoryAssociationSucceededWaiter = client.get_waiter("repository_association_succeeded")
    ```





<a id="literals"></a>

### Literals

`types_aiobotocore_codeguru_reviewer.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_codeguru_reviewer.literals import (
    AnalysisTypeType,
    CodeReviewCompletedWaiterName,
    EncryptionOptionType,
    JobStateType,
    ListRepositoryAssociationsPaginatorName,
    ProviderTypeType,
    ReactionType,
    RecommendationCategoryType,
    RepositoryAssociationStateType,
    RepositoryAssociationSucceededWaiterName,
    SeverityType,
    TypeType,
    VendorNameType,
    ServiceName,
    PaginatorName,
    WaiterName,
)

def check_value(value: AnalysisTypeType) -> bool:
    ...
````

<a id="typed-dictionaries"></a>

### Typed dictionaries

`types_aiobotocore_codeguru_reviewer.type_defs` module contains structures and
shapes assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_codeguru_reviewer.type_defs import (
    AssociateRepositoryRequestRequestTypeDef,
    AssociateRepositoryResponseTypeDef,
    BranchDiffSourceCodeTypeTypeDef,
    CodeArtifactsTypeDef,
    CodeCommitRepositoryTypeDef,
    CodeReviewSummaryTypeDef,
    CodeReviewTypeDef,
    CodeReviewTypeTypeDef,
    CommitDiffSourceCodeTypeTypeDef,
    CreateCodeReviewRequestRequestTypeDef,
    CreateCodeReviewResponseTypeDef,
    DescribeCodeReviewRequestRequestTypeDef,
    DescribeCodeReviewResponseTypeDef,
    DescribeRecommendationFeedbackRequestRequestTypeDef,
    DescribeRecommendationFeedbackResponseTypeDef,
    DescribeRepositoryAssociationRequestRequestTypeDef,
    DescribeRepositoryAssociationResponseTypeDef,
    DisassociateRepositoryRequestRequestTypeDef,
    DisassociateRepositoryResponseTypeDef,
    EventInfoTypeDef,
    KMSKeyDetailsTypeDef,
    ListCodeReviewsRequestRequestTypeDef,
    ListCodeReviewsResponseTypeDef,
    ListRecommendationFeedbackRequestRequestTypeDef,
    ListRecommendationFeedbackResponseTypeDef,
    ListRecommendationsRequestRequestTypeDef,
    ListRecommendationsResponseTypeDef,
    ListRepositoryAssociationsRequestRequestTypeDef,
    ListRepositoryAssociationsResponseTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    MetricsSummaryTypeDef,
    MetricsTypeDef,
    PaginatorConfigTypeDef,
    PutRecommendationFeedbackRequestRequestTypeDef,
    RecommendationFeedbackSummaryTypeDef,
    RecommendationFeedbackTypeDef,
    RecommendationSummaryTypeDef,
    RepositoryAnalysisTypeDef,
    RepositoryAssociationSummaryTypeDef,
    RepositoryAssociationTypeDef,
    RepositoryHeadSourceCodeTypeTypeDef,
    RepositoryTypeDef,
    RequestMetadataTypeDef,
    ResponseMetadataTypeDef,
    RuleMetadataTypeDef,
    S3BucketRepositoryTypeDef,
    S3RepositoryDetailsTypeDef,
    S3RepositoryTypeDef,
    SourceCodeTypeTypeDef,
    TagResourceRequestRequestTypeDef,
    ThirdPartySourceRepositoryTypeDef,
    UntagResourceRequestRequestTypeDef,
    WaiterConfigTypeDef,
)

def get_structure() -> AssociateRepositoryRequestRequestTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`types-aiobotocore-codeguru-reviewer` version is the same as related `boto3`
version and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/)
format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[types-aiobotocore-codeguru-reviewer docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_codeguru_reviewer/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
